# GESVideoSource

    GObject
        ╰──GInitiallyUnowned
            ╰──GESTimelineElement
                ╰──GESTrackElement
                    ╰──GESSource
                        ╰──GESVideoSource
                            ╰──GESImageSource
                            ╰──GESMultiFileSource
                            ╰──GESTitleSource
                            ╰──GESVideoTestSource
                            ╰──GESVideoUriSource

Base class for video sources

### Class structure

#### GESVideoSourceClass

##### Fields

`ABI._ges_reserved` (gpointer*) –
No description available
`ABI.abi.disable_scale_in_compositor` (gboolean) –
No description available

### GES.VideoSourceClass

## GES.VideoSource

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──GES.TimelineElement
                ╰──GES.TrackElement
                    ╰──GES.Source
                        ╰──GES.VideoSource
                            ╰──GES.ImageSource
                            ╰──GES.MultiFileSource
                            ╰──GES.TitleSource
                            ╰──GES.VideoTestSource
                            ╰──GES.VideoUriSource

Base class for video sources

## GES.VideoSource

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──GES.TimelineElement
                ╰──GES.TrackElement
                    ╰──GES.Source
                        ╰──GES.VideoSource
                            ╰──GES.ImageSource
                            ╰──GES.MultiFileSource
                            ╰──GES.TitleSource
                            ╰──GES.VideoTestSource
                            ╰──GES.VideoUriSource

Base class for video sources

### Methods

#### ges_video_source_get_natural_size

    gboolean
    ges_video_source_get_natural_size (GESVideoSource * self,
                                       gint* width,
                                       gint* height)

Retrieves the natural size of the video stream. The natural size, is the size at which it will be displayed if no scaling is being applied.

NOTE: The sources take into account the potential video rotation applied by the videoflip element that is inside the source, effects applied on the clip which potentially also rotate the element are not taken into account.

Parameters:

`self` –

A GESVideoSource

`width` ( [out]) –

The natural width of the underlying source

`height` ( [out]) –

The natural height of the underlying source

Returns –

TRUE if the object has a natural size, FALSE otherwise.

Since : 1.18

#### GES.VideoSource.prototype.get_natural_size

    function GES.VideoSource.prototype.get_natural_size(): {
        // javascript wrapper for 'ges_video_source_get_natural_size'
    }

Retrieves the natural size of the video stream. The natural size, is the size at which it will be displayed if no scaling is being applied.

NOTE: The sources take into account the potential video rotation applied by the videoflip (not introspectable) element that is inside the source, effects applied on the clip which potentially also rotate the element are not taken into account.

Parameters:

`self` (GES.VideoSource) –

A GES.VideoSource

Returns a tuple made of:

(Number ) –

TRUE if the object has a natural size, FALSE otherwise.

`width` (Number ) –

TRUE if the object has a natural size, FALSE otherwise.

`height` (Number ) –

TRUE if the object has a natural size, FALSE otherwise.

Since : 1.18

#### GES.VideoSource.get_natural_size

    def GES.VideoSource.get_natural_size (self):
        #python wrapper for 'ges_video_source_get_natural_size'

Retrieves the natural size of the video stream. The natural size, is the size at which it will be displayed if no scaling is being applied.

NOTE: The sources take into account the potential video rotation applied by the videoflip (not introspectable) element that is inside the source, effects applied on the clip which potentially also rotate the element are not taken into account.

Parameters:

`self` (GES.VideoSource) –

A GES.VideoSource

Returns a tuple made of:

(bool ) –

TRUE if the object has a natural size, FALSE otherwise.

`width` (int ) –

TRUE if the object has a natural size, FALSE otherwise.

`height` (int ) –

TRUE if the object has a natural size, FALSE otherwise.

Since : 1.18

## Constants

### GES_TYPE_VIDEO_SOURCE

    #define GES_TYPE_VIDEO_SOURCE ges_video_source_get_type()

The results of the search are